﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;

namespace DependentCellFormatting
{
    public partial class Form1 : Form
    {
        DataTable table;

        public Form1()
        {
            InitializeComponent();
            this.StartPosition = FormStartPosition.CenterScreen;
            this.Text = "Formatting Cells";
            
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ultraGrid1.DataSource = SetUpCities();
        }

        private DataTable SetUpCities()
        {
            table = new DataTable("Cities");
            table.Columns.Add("CityID", typeof(int));
            table.Columns.Add("City", typeof(string));
            table.Columns.Add("Number", typeof(int));
            table.Rows.Add(new object[] { 1, "Birmingham", 0 });
            table.Rows.Add(new object[] { 2, "Glasgow", 0 });
            table.Rows.Add(new object[] { 3, "Leeds", 0 });
            table.Rows.Add(new object[] { 4, "Liverpool", 0 });
            table.Rows.Add(new object[] { 5, "London", 0 });
            table.Rows.Add(new object[] { 6, "Manchester", 0 });
            return table;
        }

        private void ultraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].Columns[1].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.DropDownList;
            e.Layout.GroupByBox.Hidden = true;
            e.Layout.Bands[0].Columns[0].Header.Caption = "City ID";
            e.Layout.Bands[0].Columns[1].AutoCompleteMode = Infragistics.Win.AutoCompleteMode.Suggest;
            ultraGrid1.Text = "City Grid ©";    
            ultraGrid1.Font = new Font("Microsoft Sans Serif", 10.25F);
            e.Layout.Override.RowSelectors = DefaultableBoolean.True;
            e.Layout.Override.ActiveRowAppearance.BackColor = Color.Brown;
            e.Layout.Override.HeaderAppearance.BackColor = Color.LightBlue;
            e.Layout.Override.HeaderStyle = HeaderStyle.Standard;
            e.Layout.Override.HeaderAppearance.FontData.Bold = DefaultableBoolean.True;
            e.Layout.Bands[0].Override.HeaderAppearance.TextHAlign = HAlign.Center;
            e.Layout.Override.RowSelectorAppearance.BackColor = Color.LightBlue;
            e.Layout.Override.BorderStyleCell = UIElementBorderStyle.InsetSoft;
            e.Layout.Override.CellClickAction = CellClickAction.RowSelect;
        }

        private void ultraGrid1_InitializeRow(object sender, InitializeRowEventArgs e)
        {
            if ((int)e.Row.Cells["Number"].Value == 1)
            {
                e.Row.Cells["City"].Appearance.BackColor = Color.Red;
            }
            else
                if ((int)e.Row.Cells["Number"].Value == 2)
                {
                    e.Row.Cells["City"].Appearance.BackColor = Color.Green;
                }
                else
                    if ((int)e.Row.Cells["Number"].Value == 3)
                    {
                        e.Row.Cells["City"].Appearance.BackColor = Color.Blue;
                    }  
        }

        private void ultraGrid1_AfterCellUpdate(object sender, CellEventArgs e)
        {
            //if (e.Cell.Column.Key == "Number" && (int)e.Cell.Row.Cells["Number"].Value == 1)
            //{
            //    e.Cell.Row.Cells["City"].Appearance.BackColor = Color.Red;
            //}
            //else
            //    if (e.Cell.Column.Key == "Number" && (int)e.Cell.Row.Cells["Number"].Value == 2)
            //    {
            //        e.Cell.Row.Cells["City"].Appearance.BackColor = Color.Green;
            //    }
            //    else
            //        if (e.Cell.Column.Key == "Number" && (int)e.Cell.Row.Cells["Number"].Value == 3)
            //        {
            //            e.Cell.Row.Cells["City"].Appearance.BackColor = Color.Blue;
            //        }
        }

        private void updateButton_Click(object sender, EventArgs e)
        {
            int a = Convert.ToInt32(textBox1.Text);
            int b = Convert.ToInt32(textBox2.Text);
            if (a > ultraGrid1.Rows.Count)
            {
                return;
            }
            table.Rows[a]["Number"] = b;
        }
    }
}
